﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CASE_180461
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            this.DataContext = new MenuItemsDataSource();
        }
    }

    public class MenuItem : INotifyPropertyChanged
    {
        public MenuItem()
        {
            Checked = true;
        }

        string m_header;
        public string Header
        {
            get
            {
                return m_header;
            }
            set
            {
                m_header = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Header"));
                }
            }
        }

        bool m_checked;
        public bool Checked
        {
            get
            {
                return m_checked;
            }
            set
            {
                m_checked = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Checked"));
                }
            }
        }


        public IEnumerable<SubMenuItem> SubMenuItems { get; set; }

        public event PropertyChangedEventHandler PropertyChanged;
    }

    public class SubMenuItem : MenuItem { }

    public class MenuItemsDataSource : ObservableCollection<MenuItem>
    {
        public MenuItemsDataSource()
        {
            this.Add(new MenuItem() { Header = "Cars" });
            ObservableCollection<SubMenuItem> children = new ObservableCollection<SubMenuItem>();
            children.Add(new SubMenuItem() { Header = "car1" });
            children.Add(new SubMenuItem() { Header = "car2" });
            children.Add(new SubMenuItem() { Header = "car3" });
            this[0].SubMenuItems = children;
            this.Add(new MenuItem() { Header = "Trucks" });
            this.Add(new MenuItem() { Header = "Bikes" });
            ObservableCollection<SubMenuItem> children1 = new ObservableCollection<SubMenuItem>();
            children1.Add(new SubMenuItem() { Header = "bike1" });
            children1.Add(new SubMenuItem() { Header = "bike2" });
            this[2].SubMenuItems = children1;
        }
    }
}
